unit Tester;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, ComCtrls, AlignComboBox, PropCtrl, Menus,
  UniEdit, UniButton, UniList;

type
  TCTForm = class(TForm)
    StatusBar1: TStatusBar;
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    TabSheet3: TTabSheet;
    TabSheet4: TTabSheet;
    UniButton1: TUniButton;
    UniButton2: TUniButton;
    UniButton3: TUniButton;
    UniEdit1: TUniEdit;
    ComboBox1: TAlignComboBox;
    UniButton4: TUniButton;
    PopupMenu1: TPopupMenu;
    foo1: TMenuItem;
    foo11: TMenuItem;
    PropListBox1: TPropListBox;
    TabSheet5: TTabSheet;
    Memo1: TMemo;
    Panel1: TPanel;
    Button1: TButton;
    Button2: TButton;
    Button5: TButton;
    UniList1: TUniList;
    Splitter1: TSplitter;
    Panel2: TPanel;
    PropListBox2: TPropListBox;
    Label1: TLabel;
    procedure UniList1Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure UniButton2Click(Sender: TObject);
    procedure UniButton3Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure UniList1Expand(Sender: TObject; Index: Integer; ItemInfo: TItemInfo);
    procedure UniEdit1DropDown(Sender: TObject);
    procedure ComboBox1Change(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);
    procedure PropListBox1ListChanged(Sender: TObject);
    procedure PageControl1Change(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  CTForm: TCTForm;

implementation

{$R *.DFM}


procedure TCTForm.FormCreate(Sender: TObject);

  procedure FillComponentBox(const S: String; C: TComponent);
  var
    n: Integer;
  begin
    if (C = Nil) or (C.Name = '') then Exit;
    ComboBox1.Items.AddObject(S + C.Name, C);
    for n := 0 to C.ComponentCount-1 do
      FillComponentBox(S + C.Name + '.', C.Components[n]);
  end;

begin
  with UniList1 do begin
    ItemsState[0] := ItemsState[0] + isExpandable;
    ItemsState[3] := ItemsState[3] + isExpandable;
  end;
  FillComponentBox('', Self);
  PropListBox1.Designer.Form := Self;
  PageControl1Change(Self);
end;

procedure TCTForm.UniList1Click(Sender: TObject);
begin
  with UniList1 do
  StatusBar1.SimpleText := Format('%d %s %d',
    [ItemIndex, Items[ItemIndex], Ord(CheckState[ItemIndex])]);
end;

procedure TCTForm.Button1Click(Sender: TObject);
begin
  with UniList1 do
    if itemindex >= 0 then
      Hidden[ItemIndex] := not Hidden[ItemIndex];
end;

procedure TCTForm.Button2Click(Sender: TObject);
begin
  with UniList1 do
    if itemindex >= 0 then
      Disabled[ItemIndex] := not Disabled[ItemIndex];
end;

procedure TCTForm.Button3Click(Sender: TObject);
begin
  with UniList1 do
    Font.Size := Font.Size * 2;
end;

procedure TCTForm.Button4Click(Sender: TObject);
begin
  with UniList1 do
    Font.Size := Font.Size div 2;
end;

procedure TCTForm.Button5Click(Sender: TObject);
begin
  with UniList1 do
    Sorted := not Sorted;
end;


procedure TCTForm.UniButton2Click(Sender: TObject);
var
  S: String;
begin
  S := UniButton1.Caption;
  if UniButton2.Checked
  then S[Pos(' ', S)] := #10
  else S[Pos(#10, S)] := ' ';
  UniButton1.Caption := S;
end;

procedure TCTForm.UniButton3Click(Sender: TObject);
begin
  if UniButton3.Checked
  then UniButton1.SetImage(LoadIcon(0, PChar(IDI_WINLOGO)), TRUE)
  else UniButton1.SetImage(0, TRUE);
end;

procedure TCTForm.UniList1Expand(Sender: TObject; Index: Integer; ItemInfo: TItemInfo);
var
  n, i: Integer;
begin
  for n := 1 to 3 do begin
    i := Index + n;
    UniList1.Items.Insert(i, IntToStr(n+ItemInfo.Level * 1000));
    UniList1.ItemsState[i] := UniList1.ItemsState[i] + isExpandable;
  end;
end;

procedure TCTForm.UniEdit1DropDown(Sender: TObject);
begin
  with UniEdit1.PickList do begin
    ListStyle := lsCheckBox;
    ListOptions := [loAutoCheck, loPushLike, loFlatPush];
    Color := clLtGray;
    Items.Add('1');
    Items.Add('2');
    Items.Add('3');
  end;
end;

procedure TCTForm.ComboBox1Change(Sender: TObject);
begin
  with ComboBox1 do
  if ItemIndex < 0 then Exit else
  if UniButton4.Checked
  then PropListBox1.SelectAdd(TPersistent(Items.Objects[ItemIndex]))
  else PropListBox1.Select(TPersistent(Items.Objects[ItemIndex]));
end;

procedure TCTForm.Button6Click(Sender: TObject);
begin
  with TPropEditor.Create(Self) do begin
    Parent := Self;
    Visible := TRUE;
    Width := 200;
    height := 24;
  end;
end;


procedure TCTForm.Button7Click(Sender: TObject);
begin
  UniList1.Items.Move(1,2);
end;

procedure TCTForm.PropListBox1ListChanged(Sender: TObject);
var
  n: Integer;
begin
  with PropListBox1 do begin
    Items.BeginUpdate;
    for n := Items.Count-1 downto 0 do begin
      if Pos('Menu', Items[n]) <> 0 then begin
        Props[n].Free;
        Items.Delete(n);
      end else
      if Items[n] = 'Color' then Items[n] := '' else
      if Items[n] = 'Align' then Items[n] := '';
    end;
    Items.EndUpdate;
  end;
end;

procedure TCTForm.PageControl1Change(Sender: TObject);
var
  C: TControl;
begin
  case PageControl1.ActivePage.TabIndex of
    0: C := UniButton1;
    1: C := UniList1;
    2: C := UniEdit1;
    3: C := PropListBox1;
    4: C := Memo1;
    else C := Nil;
  end;
  if C <> Nil
  then Label1.Caption := ' Properties of '+C.ClassName
  else Label1.Caption := ' Properties:';
  PropListBox2.Select(C);
end;


end.
